/*
 * Copyright (C) 2013 by the University of Southern California
 * $Id: main.cc 20018 2014-02-20 00:43:21Z liangzhu $
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#include <iostream>
#include <vector>
#include <unistd.h>	// for getopt
#include <cstdlib>	// for exit
//#include <stdlib.h>    // for exit
#include "utility.hh"
//#include "query.hh"
#include "server.hh"
#include "global_var.hh"

using namespace std;

//int log_level = LOG_DEBUG;
int log_level = LOG_NONE;
//int log_level = LOG_INFO;

void usage(const char *comm) {
	cerr<<" Usage:\n "<<
		comm << "[-p port] [-s]\n"
		" -p port		port number to listen on, default is 6667\n"
		" -h			print this help message\n";
	exit(1);
}

int main (int argc, char *argv[]) 
{
	const char *comm = argv[0];	//command
	int opt = -1;
	int port_num = -1;
	bool on_tls = false;
	string tmp;
	
	while ((opt = getopt(argc, argv, "hp:")) != -1) {
		switch(opt) {
			case 'p':
				tmp = optarg;
                    		if (!is_number(tmp)) {
                    			die("-p must have a decimal number as parameter.");
                    		}
                    		port_num = atoi(optarg);	
				break;			
                    	default:
                    		usage(comm);
		}
	}
        
        if (port_num < 0) {
        	port_num = 10053;
        	warning("port_num is set to be 6667, default value.");
        }
        //start_proxy(port_num);
        start_proxy2(port_num);
        return 0;		
}

