/*
 * Copyright (C) 2013 by the University of Southern California
 * $Id: query.hh 19925 2014-02-05 23:19:04Z liangzhu $
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef QUERY_HH
#define QUERY_HH
#include <gnutls/gnutls.h>

#include <iostream>
#include <vector>
#include <cstdlib>	// for exit
#include <string.h>
#include "utility.hh"
#include "socket_util.hh"
#include "tls_util.hh"

//for resolver library routines
#include <sys/types.h>
#include <netinet/in.h>
#include <bind/arpa/nameser.h>
#include <bind/resolv.h>

#include <netdb.h> //for herror
#include "global_var.hh"
#define DNS_PORT 	53
#define MAX_BUF_SIZE 	4096
#define EDNS_SIZE 	11

#define DNS_HEADER_SIZE 12

#define ENABLE_EDNS 	0
#define ENABLE_DNSSEC	0
#define ZBIT_OFFSET 	8

/*%< EDNS0 extended message flags */
//copied from  bind/lib/dns/include/dns/message.h
#define DNS_MESSAGEEXTFLAG_DO		0x8000U
#define DNS_MESSAGEEXTFLAG_TLS		0x4000U

#define MSG_TLS_OK 			"TLS-OK"

using namespace std;

unsigned char* udp_pull_dns_pkt(int, int &, struct sockaddr*, socklen_t*);
unsigned char* tcp_pull_dns_pkt(int, int &);
unsigned char* tls_pull_dns_pkt(gnutls_session_t, int &);
void print_dns_msg(unsigned char*, int);
u_int16_t get_dns_id(unsigned char*, int);
void put_dns_id(unsigned char*, u_int16_t);
bool is_tls_set (unsigned char*, int);

unsigned char* make_tcp_pkt(unsigned char*, int &);

#endif	//QUERY_HH
