/*
 * Copyright (C) 2013 by the University of Southern California
 * $Id: server.hh 20046 2014-02-27 12:28:53Z liangzhu $
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef SERVER_HH
#define SERVER_HH

#include <iostream>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <stdio.h>	/* for perror */
#include <cstdlib>	/* for exit */
#include <cstring>	/* for memset */
#include <vector>
#include "utility.hh"
#include <unistd.h> 	/*close()*/
//#include <signal.h>
#include <sys/wait.h>       /* for waitpid() */
#include <errno.h>

#include "socket_util.hh"
#include "query.hh"

#include "global_var.hh"

//#ifdef USE_GNUTLS
///#include <gnutls/gnutls.h>
//#endif //USE_GNUTLS

//#ifdef USE_OPENSSL
#include "tls_util.hh" 
//#endif

#include <pthread.h> /*pthread*/

#include <map>
#include <list>

#define MAX_BUF_SIZE 4096
#define MIN_BUF_SIZE 50
#define DNS_SERV_PORT 53
#define DNS_SERV_IP "127.0.0.1"
#define CONN_TCP	1
#define CONN_UDP	2
#define CONN_TLS	3
#define CONN_UNKNOWN	0
#define MAX_NUM_QUERY	10000

using namespace std;

//msg type
class net_msg_t {
	public:
		unsigned char *msg;
		int len;
		struct sockaddr clnt_addr;
		socklen_t clnt_addr_len;
		net_msg_t(unsigned char *m, int l) {
			msg = m;
			len = l;
			clnt_addr_len = sizeof(clnt_addr);
		};
		net_msg_t(){
			msg = NULL;
			len = -1;
			clnt_addr_len = sizeof(clnt_addr);		
		};
		~net_msg_t(){
			if (msg != NULL) 
				delete[] msg;
			msg = NULL;
		};
		void copy(unsigned char *m, int l){
			if (msg != NULL) {
				delete[] msg;
				msg = NULL;
			}
			msg = new unsigned char[l];
			memcpy(msg, m, l);
			len = l;
		}
};

//udp client address map
struct dns_ident_t {
	u_int16_t dns_id;
	struct sockaddr clnt_addr;
	socklen_t clnt_addr_len;	
	dns_ident_t() {
		dns_id = 0;
	}
};


int start_proxy(int);
int start_proxy2(int);


#endif	//SERVER_HH
