/*
 * Copyright (C) 2013 by the University of Southern California
 * $Id: socket_util.hh 19922 2014-02-05 22:39:40Z liangzhu $
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef SOCKET_UTIL_HH
#define SOCKET_UTIL_HH

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <unistd.h>

int sendpkt(int, unsigned char *, int);
int recvpkt(int, unsigned char *, int);
int recvpkt_from(int, unsigned char *, int, struct sockaddr*, socklen_t*);
int sendpkt_to(int, unsigned char *, int, struct sockaddr*, socklen_t);
int udp_connect (int, const char *);
int tcp_connect (int, const char *);
int read_byte(int, unsigned char *, int);
int mk_conn (const char *ip, int port, bool tcp);

#endif	//SOCKET_UTIL_HH

