/*
 * Copyright (C) 2013 by the University of Southern California
 * $Id: utility.hh 19922 2014-02-05 22:39:40Z liangzhu $
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef UTILITY_HH
#define UTILITY_HH

#include <iostream>
#include <cstdlib>	/* for exit */
#include <sstream>
#include <cctype>	/* for isdigit */
#include <cstring>	/* for strlen */
#include <sys/stat.h> 	/* for stat */
#include <stdio.h>	/* for perror */
#include <vector>
#include <sys/time.h>	/* gettimeofday */
using namespace std;

#define UTIL_MAX(a, b)  (((a) > (b)) ? (a) : (b))

void die(const char*);
void warning(const char*);
void int2str(int, std::string&);
bool is_number(std::string& );
void check_path(char*, bool);
void str_split(std::string &, std::vector<std::string>&);
void trim_spaces(std::string &s);

double get_time_now(struct timeval *tv, struct timezone *tz, std::string);
double get_time_now(std::string);

#endif	//UTILITY_HH
